exports.install = function(framework) {
    framework.route('/', view_homepage);
    framework.route('/test/', view_index_logged, ['logged']);
    framework.route('/test/', view_index_unlogged);
    framework.route('/user/login/', redirect_login);
    framework.route('/user/logoff/', redirect_logoff);
};

function view_homepage() {
    var self = this;
    self.view('index');
}

function view_index_logged() {
    var self = this;
    console.log('VIEW: logged');
    self.view('logged');
}

function view_index_unlogged() {
    var self = this;
    console.log('VIEW: unlogged');
    self.view('unlogged');
}

function redirect_login() {
	var self = this;
    var auth = self.module('authorization');

    // read user information from database
    // this is an example
    var user = { id: '1', alias: 'Peter' };

    console.log('USER -> LOGIN:', user.id);

    // login
    auth.login(self, user.id, user);

	self.redirect('/test/');
}

function redirect_logoff() {
    var self = this;
    var auth = self.module('authorization');
    var user = self.user;

    if (user !== null) {
        console.log('USER -> LOGOFF:', user.id);
        auth.logoff(self, self.user.id);
    }
    
    self.redirect('/test/');
}