![partial.js logo](http://www.partialjs.com/upload/logo-christmas.png)

web application framework for node.js
=====================================

__partial.js__ is the best ever web application framework for creating a rich web sites and web services. The framework has good documentation and contains many examples. Please support the framework on GitHub and other social networks.

[![Bitdeli Badge](https://d2weczhvl823v0.cloudfront.net/petersirka/partial.js/trend.png)](https://bitdeli.com/free "Bitdeli Badge")

> Current version (v1.3.1) is Release Candidate 2 (RC 2)

__VIDEO - What's new?__: http://www.youtube.com/watch?v=-Y3LC2QmGpQ

```
$ npm install partial.js
```

- [partial.js homepage - www.partialjs.com](http://partialjs.com)
- [__Documentation__](http://docs.partialjs.com)
- [Discussion forum](https://groups.google.com/forum/#!forum/partialjs)
- [Changelog](https://github.com/petersirka/partial.js/blob/master/changes.txt)
- [__Roadmap__](https://github.com/petersirka/partial.js/blob/master/roadmap.txt)

__Development__:

- [Download empty project](http://www.partialjs.com/upload/empty-project.zip)
- [Download empty project (Visual Studio, WebMatrix / Windows)](http://www.partialjs.com/upload/empty-project-visualstudio.zip)
- [__Documentation__: Website testing on the internet (tunnel between localhost and internet)](http://docs.partialjs.com/#ngrok)
- [__Documentation__: Publish a website - REVERSE PROXY](http://docs.partialjs.com/#publish)
- [__Documentation__: partial.js for Sublime Text 2 Editor](http://docs.partialjs.com/#sublime)

__Interesting__:

- [__express.js vs partial.js__](http://www.partialjs.com/benefits/)
- [Tutorial](http://docs.partialjs.com/tutorial/)
- [Download __partial.js modules__](https://github.com/petersirka/partial.js-modules/)
- Framework supports [NoSQL Embedded database](https://github.com/petersirka/nosql) for max. 20 000 documents per database

__Social networks__:

- [__Discussion forum__](https://groups.google.com/forum/#!forum/partialjs)
- [Flattr partial.js](http://flattr.com/thing/1436218/partial-js-web-application-framework-for-node-js)
- [Follow partial.js on GitHub](https://github.com/petersirka/partial.js)
- [Follow partial.js on Twitter - __@partialjs__](https://twitter.com/partialjs)
- [Follow partial.js on Facebook](https://www.facebook.com/partialjs)
- [Follow partial.js on Google Plus](https://plus.google.com/u/0/113175077493180148081/posts)

__Examples__:

- __NEW__ - [Sushi website example](http://sushi.partialjs.com)
- __NEW__ - [TODO list example](http://todo.partialjs.com)
- [More than 90 examples](https://github.com/petersirka/partial.js/tree/master/examples)
- [HTML 5 full website example](http://www.partialjs.com/get-started/)
- Older code: [blog written in partial.js (without installation)](http://blog.partialjs.com)
- Older code: [e-shop written in partial.js (without installation)](http://eshop.partialjs.com)

__Modules__:

- [Online counter](https://github.com/petersirka/partial.js-modules/tree/master/online)
- [FileServer](https://github.com/petersirka/partial.js-modules/tree/master/fileserver)
- [FileCache](https://github.com/petersirka/partial.js-modules/tree/master/filecache)
- [FileStorage](https://github.com/petersirka/partial.js-modules/tree/master/filestorage)
- [Fulltext search engine](https://github.com/petersirka/partial.js-modules/tree/master/fulltext)
- [Authorization](https://github.com/petersirka/partial.js-modules/tree/master/authorization)
- [Session (in-memory, redis or memcached)](https://github.com/petersirka/partial.js-modules/tree/master/session)
- [Login with Facebook](https://github.com/petersirka/partial.js-modules/tree/master/facebook)
- [Less CSS - lesscss.org](https://github.com/petersirka/partial.js-modules/tree/master/less)
- [SASS CSS - www.sass-lang.com](https://github.com/petersirka/partial.js-modules/tree/master/sass)
- [Jade view engine](https://github.com/petersirka/partial.js-modules/tree/master/jade)
- [doT view engine](https://github.com/petersirka/partial.js-modules/tree/master/dot)
- [Live storage](https://github.com/petersirka/partial.js-modules/tree/master/storage)
- [Markdown parser](https://github.com/petersirka/partial.js-modules/tree/master/markdown)

__Other products__:

- [FileServer: storing of uploaded files](https://github.com/petersirka/fileserver)

Documentation
-------------
- [English documentation](http://docs.partialjs.com/)
- [Turkish documentation](https://github.com/KiPSOFT/partial.js-turkish-doc/blob/master/baslangic.md) by [KiP Software](http://www.kip-software.org/)

Do not miss
-----------

- [node.js - FileStorage](https://github.com/petersirka/node-filestorage) - storing of uploaded files (tip for partial.js)
- [node.js - Fulltext search](https://github.com/petersirka/node-fulltext) - fulltext search engine for web application (tip for partial.js)
- [node.js - PayPal Express Checkout](https://github.com/petersirka/node-paypal-express-checkout) (tip for partial.js)
- [node.js - Coucher](https://github.com/petersirka/node-couchdb) - CouchDB database provider (tip for partial.js)
- [node.js - MongoLab provider](https://github.com/petersirka/node-mongolab) - MongoLab client (tip for partial.js)
- [node.js - NoSQL embedded database](https://github.com/petersirka/nosql)
- [node.js - Backup / Restore](https://github.com/petersirka/node-backup) - Backup / Restore solution

__Client-side libraries__

- [jQuery two way bindings](https://github.com/petersirka/jquery.bindings)
- [jQuery templates - partial.js templating](https://github.com/petersirka/jquery.templates)
- [jQuery file upload (+ drag&drop)](https://github.com/petersirka/jquery.upload)
- [partial.js routing on client-side via HTML 5 history API](https://github.com/petersirka/partial.js-clientside)

***

Videos on YouTube
-----------------

- VIDEO: [Node.js / partial.js debugging of web applications](http://www.youtube.com/watch?v=4wLq_bJ_sfs)
- VIDEO: [partial.js / node.js - balancing of requests](http://www.youtube.com/watch?v=1VOJ7cWoboo)
- VIDEO: [HTML 5 Server-Sent Events (JavaScript) via partial.js & node.js](http://www.youtube.com/watch?v=XoWIv3xGxR4)
- VIDEO: [node.js / partial.js - Live streaming via multipart/x-mixed-replace + CSS auto vendor prefix](http://www.youtube.com/watch?v=qZqO4c4Fw2k)
- VIDEO: [Deployment of partial.js / node.js website on appfog.com (freehosting)](http://www.youtube.com/watch?v=kZvCCyR6iBI)
- VIDEO: [WebSocket (Real-time) HTML5 Chat in 5 minutes - node.js & partial.js](http://www.youtube.com/watch?v=lW1vsKMUaKg)
- VIDEO: [partial.js / web application framework for node.js](http://www.youtube.com/watch?v=3GMQJki82Lo)

***

* **NEW** Supports workers - [example: workers](https://github.com/petersirka/partial.js/tree/master/examples/workers)
* **NEW** Supports versioning of static files - [example: static-version](https://github.com/petersirka/partial.js/tree/master/examples/static-version)
* Supports redirects - [example: host redirect](https://github.com/petersirka/partial.js/tree/master/examples/redirect-host)
* Supports restrictions - [example: restrictions](https://github.com/petersirka/partial.js/tree/master/examples/framework-restrictions)
* Controller proxy - [example: proxy](https://github.com/petersirka/partial.js/tree/master/examples/controller-proxy)
* Supports server sent events - [example: server sent events](https://github.com/petersirka/partial.js/tree/master/examples/server-sent-events)
* Supports live streaming via multipart/x-mixed-replace - [example: live streaming](https://github.com/petersirka/partial.js/tree/master/examples/live-streaming)
* Supports uploading via multipart/x-mixed-replace - [example: live uploading](https://github.com/petersirka/partial.js/tree/master/examples/live-streaming-upload)
* Supports CSS auto vendor prefixes - [read the benefits](http://www.partialjs.com/benefits/)
* Supports Websocket (Standard - RFC 6455) - [example: websocket](https://github.com/petersirka/partial.js/tree/master/examples/websocket)
* Async web framework - [example: async methods](https://github.com/petersirka/partial.js/tree/master/examples/async)
* Simple view engine - [example: view engine](https://github.com/petersirka/partial.js/tree/master/examples/views)
* Simple routing + support flags ['xhr', 'post', 'put', 'delete', 'logged', etc.] - [example: routing flags](https://github.com/petersirka/partial.js/tree/master/examples/routing-flags)
* Simple cacheing - [example: http cache example](https://github.com/petersirka/partial.js/tree/master/examples/cache-http), [partial cache example](https://github.com/petersirka/partial.js/tree/master/examples/cache-partial)
* Simple directory structure (controllers, modules, public, logs, tmp, templates, views, resources)
* Simple code structure
* Simple error handling
* Simple cookie manipulation - [example: cookies](https://github.com/petersirka/partial.js/tree/master/examples/cookies)
* Simple listing via templates - [example: listing via templates](https://github.com/petersirka/partial.js/tree/master/examples/templating)
* XSS protection - [example: XSS](https://github.com/petersirka/partial.js/tree/master/examples/framework-xss-protection)
* Share controller functions and models over the framework - [example: controller sharing](https://github.com/petersirka/partial.js/tree/master/examples/controller-sharing)
* __Assertion Testing__ - [example: testing](https://github.com/petersirka/partial.js/tree/master/examples/testing)
* Supports custom helpers - [example: custom helpers](https://github.com/petersirka/partial.js/tree/master/examples/View-custom-helper)
* Supports routing to static file for dynamic creating static file - [example: routing](https://github.com/petersirka/partial.js/tree/master/examples/routing)
* Supports controller sharing between other controllers - [example: controller sharing](https://github.com/petersirka/partial.js/tree/master/examples/controller-sharing)
* Supports debug mode with custom settings without cache - [example: debug mode](https://github.com/petersirka/partial.js/tree/master/examples/config-debug-release)
* Supports file upload - [example: file upload](https://github.com/petersirka/partial.js/tree/master/examples/upload-multipart)
* Supports copy&paste custom code between projects - [example: framework-custom](https://github.com/petersirka/partial.js/tree/master/examples/framework-custom)
* __Supports modules__ (module can create a route, view, template, resource, etc.) - [example: module](https://github.com/petersirka/partial.js/tree/master/examples/framework-modules)
* __Supports inject config from URL__ - [example: config inject](https://github.com/petersirka/partial.js/tree/master/examples/framework-inject-config)
* __Supports inject module from URL__ - [example: module inject](https://github.com/petersirka/partial.js/tree/master/examples/framework-inject-module)
* __Supports inject controller from URL__ - [example: controller inject](https://github.com/petersirka/partial.js/tree/master/examples/framework-inject-controller)
* __Supports inject definition from URL__ - [example: definition inject](https://github.com/petersirka/partial.js/tree/master/examples/framework-inject-definition)
* Supports form data validation - [example: validation](https://github.com/petersirka/partial.js/tree/master/examples/validation)
* Supports simple log writer - [example: logs](https://github.com/petersirka/partial.js/tree/master/examples/logs)
* Supports simple restrictions - [example: restriction](https://github.com/petersirka/partial.js/tree/master/examples/restrictions-ip)
* Supports serve static files and custom handling static files - [example: static-file-handling](https://github.com/petersirka/partial.js/tree/master/examples/static-file-handling)
* __Supports streaming static files__ - implemented Accept-Ranges - [example: video-streaming](https://github.com/petersirka/partial.js/tree/master/examples/video-streaming)
* Supports HTML minification
* Supports JavaScript compress
* Supports JavaScript dynamic compress in views - [example: dynamic JavaScript compress](https://github.com/petersirka/partial.js/tree/master/examples/views-javascript-compress)
* Supports simple LESS CSS (with compress) - [example: LESS CSS](https://github.com/petersirka/partial.js/tree/master/examples/css-less)
* Supports resources (for multilanguage pages) - [example: resources](https://github.com/petersirka/partial.js/tree/master/examples/localization-resources)
* __Supports prefixes for mobile devices__ - [example: prefixes](https://github.com/petersirka/partial.js/tree/master/examples/mobile)
* Supports SMTP mail sender (attachment, HTML, basic authentication) - [example: SMTP mail sender](https://github.com/petersirka/partial.js/tree/master/examples/email-templating)
* Supports simple mail templating - [example: mail templating](https://github.com/petersirka/partial.js/tree/master/examples/email-templating)
* Supports custom authorization - [example: authorization](https://github.com/petersirka/partial.js/tree/master/examples/authorization)
* Supports basic access authentication - [example: basic access authentication](https://github.com/petersirka/partial.js/tree/master/examples/authorization-www-basic)
* Supports simple image processing (resize, grayscale, etc.) via GraphicsMagick/ImageMagick - [example: image-resize](https://github.com/petersirka/partial.js/tree/master/examples/image-resize)
* Easy adding dynamic META tags in views or controllers - [example: meta tags](https://github.com/petersirka/partial.js/tree/master/examples/views-meta)
* Easy adding dynamic Settings in views or controllers - [example: view settings](https://github.com/petersirka/partial.js/tree/master/examples/views-settings)
* Simple use paypal payment with [example: node-paypal project](https://github.com/petersirka/node-paypal) - [example: paypal](https://github.com/petersirka/partial.js/tree/master/examples/paypal)
* Supports simple pagination builder - [example: pagination builder](https://github.com/petersirka/partial.js/tree/master/examples/paging)
* Supports live usage information - [example: framework usage](https://github.com/petersirka/partial.js/tree/master/examples/framework-usage)
* Supports dynamic stop server - [example: stop server](https://github.com/petersirka/partial.js/tree/master/examples/framework-stop)
* Supports verification of framework - [example: verification](https://github.com/petersirka/partial.js/tree/master/examples/framework-verification)
* About 9 000 lines of JavaScript code, all files have 270 kB
* __NO DEPENDENCIES *** NO DEPENDENCIES *** NO DEPENDENCIES__
* [More examples](https://github.com/petersirka/partial.js/tree/master/examples)
* [Documentation](http://www.partialjs.com/documentation/)
* __Supports internal NoSQL embedded database__ - [example: authorization](https://github.com/petersirka/partial.js/tree/master/examples/authorization) or [example: contact form](https://github.com/petersirka/partial.js/tree/master/examples/contact-form)

***

## WebSocket (Real-time) HTML5 Chat in 5 minutes

[![partial.js example](http://partialjs.com/img/video.jpg)](http://www.youtube.com/watch?v=lW1vsKMUaKg)

***

## Install partial.js step by step

![partial.js on NPM](https://nodei.co/npm/partial.js.png?downloads=true)

```
$ sudo npm install -g partial.js
```
```
$ mkdir mywebsite
$ cd mywebsite
$ partial.js
```
```
$ node debugging

# OR

$ node index 8080
```
```
$ open http://127.0.0.1:8000
```

## The MIT License

Copyright (c) 2012-2013 Peter Širka <petersirka@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

## Contact

[www.petersirka.sk](http://www.petersirka.sk) - <petersirka@gmail.com>
